#include <windows.h>
#include <stdint.h>
#include <stdio.h>
#include <string.h>
#include <ddk/imm.h>
#include "cannaapi.h"
#include "ut.h"
#include "apisup.h"

Array Clients;
Array Context;
unsigned SerialNumber; //ƥȤֹ̤

HWND NewWin();

void reset_client_data(ClientData_t* cdt,int fd,const char* user);
CannaContext_t* reset_context(CannaContext_t* c,int fd,HWND wh);
void cd_constructor(void* p);
void cx_constructor(void* p);
int eq_wnd(const void *val,const void *elem);
int eq_fd(const void *val,const void *elem);


//wh=Х륳ƥȤ˻Ȥhwnd
void InitClientData(HWND wh)
{
    ArNew(&Clients,sizeof(ClientData_t),cd_constructor);
    Clients.pagesize = 8;
    ArNew(&Context,sizeof(CannaContext_t),cx_constructor);
    Context.pagesize = 8;
    OpenContext(0,wh,NULL);
}

//ʣʤ˳ǧƤ
int16_t OpenConnection(int fd,const char* user)
{
    int16_t cxn;
    ClientData_t* cdt = ArFindElemIf(&Clients,eq_fd,0);
    reset_client_data(cdt,fd,user);
    OpenContext(fd,NewWin(),&cxn);
    return cxn;
}

//եǥץfdΥ饤Ⱦ
int CloseConnection(int fd)
{
    void close_cx(CannaContext_t* cx){
	if(cx->Connection==fd && cx->Win!=NULL)
	    CloseContext(cx);
    }

    int n;
    if((n = FindClient(fd)) >= 0){
	ClientData_t* cdt = ArElem(&Clients,n);
	cdt->Connection = 0;
	free(cdt->User);
	free(cdt->App);
	free(cdt->Group);
	ArForEach(&Context,(AR_FOREACH)close_cx);
    }else
	VERBOSE(DBG("already closed fd %d\n",fd));
    return n>=0;
}

int FindClient(int fd)
{
    return ArFindIf(&Clients,0,eq_fd,(void*)fd);
}

int16_t context_number(const CannaContext_t* cx)
{
    return cx - (const CannaContext_t*)(Context.adr);
}

CannaContext_t* OpenContext(int fd,HWND wh,int16_t *cxn)
{
    CannaContext_t* cx = ArFindElemIf(&Context,eq_wnd,NULL);
    reset_context(cx,fd,wh);
    cx->SerialNum = SerialNumber++;
    if(cxn != NULL)
	*cxn = context_number(cx);
    return cx;
}

void CloseContext(CannaContext_t* cx)
{
    if(cx != NULL){
	if(!ImmDestroyContext(ImmAssociateContext(cx->Win,NULL)))
	    VERBOSE(DBG("fail ImmDestroyContext\n"));
	DestroyWindow(cx->Win);
	cx->Win = NULL;
	ArDelete(&cx->CandInfo);
	ArDelete(&cx->FixedStr);
	ArDelete(&cx->FixedYomi);
	ArDelete(&cx->Dics);
	ArDelete(&cx->DicMode);
	VERBOSE(DBG("close context %hd\n",context_number(cx)));
    }
}

//fdγǧ⤹뤫
CannaContext_t* ValidContext(int cxn,const char* msgtag)
{
    CannaContext_t* cx = ArElem(&Context,cxn);
    if(cxn<0 || cxn>=Context.using || cx->Win==NULL){
	VERBOSE(DBG("%s:invalid context %hd\n",msgtag,cxn));
	cx = NULL;
    }
    return cx;
}

CannaContext_t* FindContext(HWND wh,int16_t* cxn)
{
    *cxn = ArFindIf(&Context,0,eq_wnd,wh);
    return *cxn!=-1 ? ArElem(&Context,*cxn) : NULL;
}

void reset_client_data(ClientData_t* cdt,int fd,const char* user)
{
    cdt->Connection = fd;
    cdt->User = user==NULL ? NULL : strdup(user);
    cdt->App = cdt->Group = NULL;
}

CannaContext_t* reset_context(CannaContext_t* cx,int fd,HWND wh)
{
    cx->Win = wh;
    cx->Connection = fd;
    ArClear(&cx->CandInfo);
    cx->FixedNum = 0;
    ArClear(&cx->FixedStr);
    ArClear(&cx->FixedYomi);
    ArClear(&cx->Dics);
    ArClear(&cx->DicMode);
    return cx;
}

CannaContext_t* ResetContext(CannaContext_t* cx)
{
    return reset_context(cx,cx->Connection,cx->Win);
}

void cd_constructor(void* p)
{
    reset_client_data((ClientData_t*)p,0,NULL);
}

void candinfo_c(void* p)
{
    memset(p,0,sizeof(CandListPageInfo));
}

void cx_constructor(void* p)
{
    CannaContext_t* cx = (CannaContext_t*)p;
    ArNew(&(cx->CandInfo),sizeof(CandListPageInfo),candinfo_c);
    cx->CandInfo.pagesize = 16;
    cx->Win = NULL;
    cx->FixedNum = 0;
    cx->SerialNum = SerialNumber++;
    ArNew(&cx->FixedStr,2,NULL);
    ArNew(&cx->FixedYomi,2,NULL);
    ArNew(&cx->Dics,1,NULL);
    ArNew(&cx->DicMode,4,NULL);
}

int eq_wnd(const void *val,const void *elem)
{
    return val==((CannaContext_t*)elem)->Win;
}

int eq_fd(const void *val,const void *elem)
{
    return (int)val == ((const ClientData_t*)elem)->Connection;
}

////////////////////////////////////////////////////////////////////////

uint16_t Req2(char *data)
{
    return Swap2(*(uint16_t*)data);
}

void* Req3(char *data,int16_t *p1,uint16_t *p2)
{
    *p1 = Swap2c(data);
    *p2 = Swap2c(data+2);
    return data+4;
}

//cannawcharʸޥХʸˤ
char* Req4(char* data,int16_t* p1,uint16_t* p2,uint16_t* p3,uint16_t* p4)
{
    return ToMb(data,Req9(data,p1,(int16_t*)p2,(int16_t*)p3,(int16_t*)p4));
}

void Req5(char *data,int16_t *p1,uint16_t *p2,int32_t* p3)
{
    Req10(data,p1,(int16_t*)p2,p3,0);
}

void Req6(char *data,int16_t *p1,int16_t *p2,uint16_t *p3)
{
    Req9(data,p1,p2,(int16_t*)p3,NULL);
}

void Req7(char* data,int16_t* p1,int16_t* p2,int16_t* p3)
{
    Req9(data,p1,p2,p3,NULL);
}

void Req8(char* data,int16_t* p1,int16_t* p2,int16_t* p3,uint16_t* p4)
{
    Req9(data,p1,p2,p3,(int16_t*)p4);
}

void* Req9(char* data,int16_t* p1,int16_t* p2,int16_t* p3,int16_t* p4)
{
    int16_t *p[]={p1,p2,p3,p4};
    int n;
    for(n=0; n<4; ++n,data+=2)
	if(p[n] != NULL)
	    *p[n] = Swap2c((uint16_t*)data);
    return data;
}

void *Req10(char *data,int16_t *p1,int16_t *p2,int32_t *p3,int sz)
{
    int16_t *p;
    *p1 = Swap2c(data);
    *p2 = Swap2c(data+2);
    *p3 = Swap4c(data+4);
    for(p=(int16_t*)(data+8),sz-=8; sz>0; ++p,sz-=2){
	Swap2p(p,1);
    }
    return data+8;
}

uint16_t* Req11r(char* data,int16_t* p1,int16_t* p2)
{
    return (uint16_t*)Req3(data,p1,(uint16_t*)p2);
}

char* Req11(char* data,int16_t* p1,int16_t* p2)
{
    uint16_t* p3 = Req3(data,p1,(uint16_t*)p2);
    return ToMb((char*)p3,p3);
}

//cannawcharʸޥХʸˤ
char* Req12(char* data,int16_t* p1,char** p2)
{
    *p1 = Swap2c(data);
    *p2 = (data += 2);
    data = (char*)(WcChr((uint16_t*)data,0)+1);
    *p2 = ToMb(*p2,(uint16_t*)*p2);
    return data;
}

char* Req13(char* data,int16_t* p1,char** p3,uint16_t* p4,uint16_t* p5,uint16_t* p6)
{
    uint16_t *wp;
    *p1 = Swap2c(data);
    *p3 = strchr(data+2,0)+1;
    wp = WcChr((uint16_t*)*p3,0)+1;
    *p4 = *(wp++);
    *p5 = *(wp++);
    *p6 = *(wp++);
    ToMb(*p3,(uint16_t*)*p3);
    return data+2;
}

//cannawcharʸޥХʸˤ
char* Req14(char *data,int32_t *p1,int16_t *p2)
{
    data = Req15(data,p1,p2);
    return ToMb(data,(uint16_t*)data);
}

void* Req15(char *data,int32_t *p1,int16_t *p2)
{
    *p1 = Swap4c(data);
    *p2 = Swap2c(data+4);
    return data+6;
}

//ޥ˥奢Ǥϥ18ȥ֤äƤListDirectory(1-7)˻ȤȤˤ
uint16_t Req16(char* data,int16_t* p1,char** p2)
{
    *p1 = Swap2c(data);
    *p2 = data+2;
    return Swap2c(strchr(*p2,0)+1);
}

uint16_t Req18(char* data,int16_t* p1,char** p2,char** p3)
{
    *p1 = Swap2c(data);
    *p2 = data+2;
    *p3 = strchr(*p2,0)+1;
    return Swap2c(strchr(*p3,0)+1);
}

char* Req19(char* data,int32_t* p1,int16_t* p2,char** p3)
{
    *p3 = Req15(data,p1,p2);
    return strchr(*p3,0)+1;
}

char* Req21(char* data,int32_t* p1,int16_t* p2,char** p3,char** p4)
{
    *p4 = Req19(data,p1,p2,p3);
    return strchr(*p4,0)+1;
}

//----------------------------------------------------

bool Reply2(uint8_t mj,uint8_t mn,char st)
{
    CannaHeader ch;

    ch.Major = mj;
    ch.Minor = mn;
    ch.Length = Swap2(1);
    return FuncWrite(&ch,CANNAHEADERSIZE) && 
	FuncWrite(&st,1);
}

bool Reply3(uint8_t mj,uint8_t mn,char st,const uint16_t* data,int len)
{
    CannaHeader ch;

    ch.Major = mj;
    ch.Minor = mn;
    ch.Length = Swap2(1+len);
    return FuncWrite(&ch,CANNAHEADERSIZE) &&
	FuncWrite(&st,1) && 
	(len==0 ? true : FuncWrite(data,len));
}
    
bool Reply4(uint8_t mj,uint8_t mn,char p1,const int32_t* data,int num)
{
    CannaHeader ch;
    int32_t le[num];

    for(int n=0; n<num; ++n)
	le[n] = Swap4(data[n]);
    ch.Major = mj;
    ch.Minor = mn;
    ch.Length = Swap2(1+num*4);
    return FuncWrite(&ch,CANNAHEADERSIZE) &&
	FuncWrite(&p1,1) &&
	FuncWrite(le,num*4);
}

bool Reply5(uint8_t mj,uint8_t mn,int16_t st)
{
    CannaHeader ch;

    ch.Major = mj;
    ch.Minor = mn;
    ch.Length = Swap2(2);
    return FuncWrite(&ch,CANNAHEADERSIZE) &&
	FuncWrite(Swap2p(&st,1),2);
}

bool Reply6(uint8_t mj,uint8_t mn,uint16_t i,const char* str,int len)
{
    return Reply7(mj,mn,i,(uint16_t*)str,len);
}

//len=̥ޤХȿ
bool Reply7(uint8_t mj,uint8_t mn,uint16_t i,uint16_t *str,int len)
{
    CannaHeader ch;
    bool st;

    if(str == NULL)
	len = 0;
    ch.Major = mj;
    ch.Minor = mn;
    ch.Length = Swap2(2+len);
    st = FuncWrite(&ch,CANNAHEADERSIZE) &&
	FuncWrite(Swap2p(&i,1),2);
    if(st && str!=NULL)
	st = FuncWrite(str,len);
    return st;
}

bool Reply11(uint8_t mj,uint8_t mn,int p1,int p2,int p3,const char* p4)
{
    int p4len,p123[]={p1,p2,p3};
    CannaHeader ch;
    bool st;

    for(int n=0; n<3; ++n)
	RevInt(p123+n);
    p4len = (p4!=NULL ? strlen(p4)+1 : 0);
    ch.Major = mj;
    ch.Minor = mn;
    ch.Length = Swap2(sizeof(p123)+p4len);
    st = (FuncWrite(&ch,CANNAHEADERSIZE) && FuncWrite(p123,sizeof(p123)));
    if(st && p4!=NULL)
	st = FuncWrite(p4,p4len);
    return st;
}

////////////////////////////////////////////////////////////////////////

void dbg_attr(const char* tag,char* a,int len)
{
    char sel,cnv;

    DBGP("\t%s-attr:size %d:",tag,len);
    for(int n=0; n<len; ++n){
	sel=cnv='-';
	switch(*(a++)){
	case ATTR_INPUT://̤,̤Ѵ
	    break;
	case ATTR_TARGET_CONVERTED://,Ѵ
	    sel='s'; cnv='c';
	    break;
	case ATTR_CONVERTED:	//̤,Ѵ
	    cnv='c';
	    break;
	case ATTR_TARGET_NOTCONVERTED:	//,̤Ѵ
	    sel='s';
	    break;
	case ATTR_INPUT_ERROR:	//̵
	    sel=cnv='x';
	    break;
	case ATTR_FIXEDCONVERTED:
	    cnv='f';
	    break;
	default:	//°
	    sel=cnv='?';
	}
	DBGP("[%c%c]",sel,cnv);
    }
    DBGP("\n");
}

void dbg_str(const char* tag,COMPOSITIONSTRING* cs,int stroffset,
	     int cloffset,int cllen,
	     int atoffset,int atlen,
	     void (*dbg_str_to_sjmb)(char* buf,uint16_t* str,int len))
{
    uint16_t* str = (uint16_t*)((char*)cs+stroffset);
    uint32_t* cl = (uint32_t*)((char*)cs+cloffset);
    cllen /= 4;
    char sj[cl[cllen-1]*2+1],ej[sizeof(sj)];

    DBGP("\t%s-clause:size %d:",tag,cllen);
    Dump4(" %d",cl,cllen,1);
    if(atoffset!=0)
	dbg_attr(tag,(char*)cs+atoffset,atlen);
    printf("\t%s-str=",tag);
    for(int n=0; n<cllen-1; ++n){
	dbg_str_to_sjmb(sj,str+cl[n],cl[n+1]-cl[n]);
	ConvCode(ej,sj,Sj2Ej);
	printf("[%s]",ej);
    }
    printf("\n");
}

void dbg_str_to_sjmb_comp(char* buf,uint16_t* str,int len)
{
    buf[WideCharToMultiByte(CP_ACP,0,str,len,buf,-1,NULL,NULL)] = 0;
}

void dbg_str_to_sjmb_read(char* buf,uint16_t* str,int len)
{
    SjStrHan2Zen(buf,(char*)str,2,0x40,0,len);
}

void DbgComp(HIMC imc,const char *tag)
{
    INPUTCONTEXT *ic = (INPUTCONTEXT*)ImmLockIMC(imc);
    COMPOSITIONSTRING *cs = (COMPOSITIONSTRING*)ImmLockIMCC(ic->hCompStr);

    printf("%s:COMPOSITIONSTRING debug\n",tag);
    dbg_str("comp",cs,cs->dwCompStrOffset,cs->dwCompClauseOffset,cs->dwCompClauseLen,cs->dwCompAttrOffset,cs->dwCompAttrLen,dbg_str_to_sjmb_comp);
    dbg_str("read",cs,cs->dwCompReadStrOffset,cs->dwCompReadClauseOffset,cs->dwCompReadClauseLen,cs->dwCompReadAttrOffset,cs->dwCompReadAttrLen,dbg_str_to_sjmb_read);
    dbg_str("result",cs,cs->dwResultStrOffset,cs->dwResultClauseOffset,cs->dwResultClauseLen,0,0,dbg_str_to_sjmb_comp);
    dbg_str("result-read",cs,cs->dwResultReadStrOffset,cs->dwResultReadClauseOffset,cs->dwResultReadClauseLen,0,0,dbg_str_to_sjmb_read);

    ImmUnlockIMCC(ic->hCompStr);
    ImmUnlockIMC(imc);
}

/*
  ߤʸƱ=-1
  =0
  =1
*/
int change_attr(int target,char *attr,const int32_t *cls,int clslen)
{
    char a,*bp;
    int n,cur;
    
    //ߤʸ򸫤Ĥ
    for(cur=0; cur<clslen-1; ++cur)
	if(a=attr[cls[cur]],
	   (a==ATTR_TARGET_CONVERTED||a==ATTR_TARGET_NOTCONVERTED))
	    break;
    VERBOSE(DBG("target change %d --> %d\n",cur,target));
    if(cur == clslen-1){
	VERBOSE(DBG("ʸ᤬ʤ\n"));
	return 0; //ʸ᤬ʤ
    }
    if(cur == target)
	return -1; //ߤʸƱ

    //򤵤Ƥʬ̤ˤ
    for(n=cls[cur+1]-cls[cur],bp=attr+cls[cur]; n>0; --n,++bp)
	switch(*bp){
	case ATTR_TARGET_CONVERTED:
	    *bp = ATTR_CONVERTED;
	    break;
	case ATTR_TARGET_NOTCONVERTED:
	    *bp = ATTR_INPUT;
	}

    //ʸ򤹤
    for(n=cls[target+1]-cls[target],bp=attr+cls[target]; n>0; --n,++bp)
	switch(*bp){
	case ATTR_CONVERTED:
	    *bp = ATTR_TARGET_CONVERTED;
	    break;
	case ATTR_INPUT:
	    *bp = ATTR_TARGET_NOTCONVERTED;
	}
    return 1;
}

/*
  ʸѹ
  tn=ʸֹ(0)
*/
ChangeTargetStatus ChangeTargetClause(HIMC imc,int tn,const CannaContext_t* cx)
{
    int alen,readalen,r0,r1,clslen,readclslen;
    int32_t *cls,*readcls;
    INPUTCONTEXT *ic=(INPUTCONTEXT*)ImmLockIMC(imc);
    COMPOSITIONSTRING *cs=(COMPOSITIONSTRING*)ImmLockIMCC(ic->hCompStr);

    if(tn < cx->FixedNum)
	return ChangeTargetFixed; //ʸϤɤ褦ʤ
    tn -= cx->FixedNum;

    /*
      readclsʤɤImmGetCompositionString()ǤȤäƤ٤
      wine1.0rc1ǤfixmeˤʤäƤΤǡľܹ¤Τ򸫤뤳Ȥˤ
    */
    char attr[alen=cs->dwCompAttrLen],readattr[readalen=cs->dwCompReadAttrLen];
    memcpy(attr,(char*)cs+cs->dwCompAttrOffset,alen);
    memcpy(readattr,(char*)cs+cs->dwCompReadAttrOffset,readalen);

    clslen = cs->dwCompClauseLen/4;
    cls = (int32_t*)((char*)cs+cs->dwCompClauseOffset);
    readclslen = cs->dwCompReadClauseLen/4;
    readcls = (int32_t*)((char*)cs+cs->dwCompReadClauseOffset);

    //VERBOSE(DBG("befer change\n");DbgComp(imc,__FUNCTION__));
    if((r0 = change_attr(tn,attr,cls,clslen)))
       r1 = change_attr(tn,readattr,readcls,readclslen);
    ImmUnlockIMCC(ic->hCompStr);
    ImmUnlockIMC(imc);

    /*
      wineImmSetCompositionString()ǤAWˤݥǡ̵wcharˤΤǡcharɬפʥޥɤλW褵
       compreadξꤷʤȼԤ
    */
    if(r0<0)
	VERBOSE(DBG("clause %d is current cl.\n",cx->FixedNum+tn));
    if(r0>0 && r1>0){
	if(!(r0 = ImmSetCompositionStringW(imc,SCS_CHANGEATTR,attr,alen,readattr,readalen)))
	    DBG("fail ImmSetCompositionStringW\n");
#if 0
	else{
	    //??? ImmNotifyIMEɬפ
	    r0 = ImmNotifyIME(imc,NI_COMPOSITIONSTR,CPS_CONVERT,0);
	    if(r0){
		VERBOSE(DBG("after change\n"); DbgComp(imc,__FUNCTION__));
	    }else
		DBG("fail ImmNotifyIME\n");
	}
#endif
    }
    return (r0!=0 ? ChangeTargetSuccess:ChangeTargetFail);
}

//ʸcxΥФ¸롣(ǡ¸)
void SaveFixedClause(HIMC imc,CannaContext_t* cx)
{
    int32_t *cl,*rcl;
    uint16_t *uni,*yo;
    INPUTCONTEXT *ic=(INPUTCONTEXT*)ImmLockIMC(imc);
    COMPOSITIONSTRING *cs=(COMPOSITIONSTRING*)ImmLockIMCC(ic->hCompStr);

    cl = (int32_t*)((char*)cs+cs->dwResultClauseOffset);
    uni = (uint16_t*)((char*)cs+cs->dwResultStrOffset);
    rcl = (int32_t*)((char*)cs+cs->dwResultReadClauseOffset);
    yo = (uint16_t*)((char*)cs+cs->dwResultReadStrOffset);
    for(int n=0; n<(int)(cs->dwResultClauseLen)/4-1; ++n){
	wstr_add_nwcs(&cx->FixedStr,uni+cl[n],cl[n+1]-cl[n]);
	wstr_add_wc(&cx->FixedStr,0);

	wstr_add_nwcs(&cx->FixedYomi,yo+rcl[n],rcl[n+1]-rcl[n]);
	wstr_add_wc(&cx->FixedYomi,0);

	++ cx->FixedNum;
    }
    ImmUnlockIMCC(ic->hCompStr);
    ImmUnlockIMC(imc);
}

/*
  ʸֹnѴʸeucjpˤ
  ejΥ֥å=2
  ejϥꥢ롣̥ʸɲäʤ
  atnullǤʤ°֤
*/
Array* ClauseStr(HIMC imc,int n,Array *ej,int le,char* at,const CannaContext_t* cx)
{
    INPUTCONTEXT *ic=(INPUTCONTEXT*)ImmLockIMC(imc);
    COMPOSITIONSTRING *cs=(COMPOSITIONSTRING*)ImmLockIMCC(ic->hCompStr);
    uint16_t *uni;
    char a;
    int len;

    if(n < cx->FixedNum){
	//nϸʸؤƤ
	uni = StrListNthWc(cx->FixedStr.adr,cx->FixedNum,n);
	len = WcLen(uni);
	a = ATTR_FIXEDCONVERTED; //??? ֤󤳤ΤȤ
    }else{
	n -= cx->FixedNum; //ʸ᤬Фʸޤƹͤ
	int32_t* cl = (int32_t*)((char*)cs+cs->dwCompClauseOffset);
	uni = (uint16_t*)((char*)cs+cs->dwCompStrOffset) + cl[n];
	len = cl[n+1]-cl[n];
	a = *((char*)cs+cs->dwCompAttrOffset+cl[n]);
    }

    if(ej != NULL){
	int sjmax = len*2+1;
	char sj[sjmax];
	ArClear(ej);
	WcToMb(uni,len,sj,sjmax);
	wstr_add_sj2ej(ej,sj,le);
    }
    if(at != NULL)
	*at = a;

    ImmUnlockIMCC(ic->hCompStr);
    ImmUnlockIMC(imc);
    return ej;
}

//ʸ֤
int ClauseLen(HIMC imc,const CannaContext_t* cx)
{
    INPUTCONTEXT* ic=(INPUTCONTEXT*)ImmLockIMC(imc);
    COMPOSITIONSTRING* cs=(COMPOSITIONSTRING*)ImmLockIMCC(ic->hCompStr);
    int len=0;
    if(cs->dwCompClauseLen > 0)
	len += cs->dwCompClauseLen/4-1;//ʸ(-1)
    ImmUnlockIMCC(ic->hCompStr);
    ImmUnlockIMC(imc);
    return cx->FixedNum + len;
}

/*
  n1ʸᤫn2ʸޤǤɤʸeucjp֤
  e->blocksize == 2
  eϥꥢ롣
  e˥̥ʸϤĤusingˤϥȤʤ
*/
Array* GetInputClause(HIMC imc,int n1,int n2,const CannaContext_t* cx,Array* e)
{
    INPUTCONTEXT *ic = (INPUTCONTEXT*)ImmLockIMC(imc);
    COMPOSITIONSTRING *cs = (COMPOSITIONSTRING*)ImmLockIMCC(ic->hCompStr);
    Array src;

    ArNew(&src,2,NULL);
    while(n1 < min(cx->FixedNum,n2+1)){
	wstr_add_wcs(&src,StrListNthWc(cx->FixedYomi.adr,cx->FixedNum,n1++));
    }
    if(n2 >= cx->FixedNum){
	n1 -= cx->FixedNum;
	n2 -= cx->FixedNum;
	if(n1 <= n2){
	    int32_t* rcl = (int32_t*)((char*)cs+cs->dwCompReadClauseOffset);
	    uint16_t* han = (uint16_t*)((char*)cs+cs->dwCompReadStrOffset)+rcl[n1];
	    wstr_add_nwcs(&src,han,rcl[n2+1]-rcl[n1]);
	}
    }
    wstr_add_wc(&src,0); //̥ʸɲäƤ
    SjStrHan2Zen(src.adr,src.adr,2,0x40,1,src.using);
    ArClear(e);
    wstr_add_sj2ej(e,src.adr,0);
    wstr_add_wc(e,0);
    -- e->using; //̥ʸϥȤʤ

    ArDelete(&src);
    ImmUnlockIMCC(ic->hCompStr);
    ImmUnlockIMC(imc);
    return e;
}

/*
  ɤʸΤʸ֤
*/
int InputLen(HIMC imc,CannaContext_t* cx)
{
    INPUTCONTEXT *ic = (INPUTCONTEXT*)ImmLockIMC(imc);
    COMPOSITIONSTRING *cs = (COMPOSITIONSTRING*)ImmLockIMCC(ic->hCompStr);
    int32_t* rcl = (int32_t*)((char*)cs+cs->dwCompReadClauseOffset);
    int hanlen = rcl[cs->dwCompReadClauseLen/4-1];
    char sjzen[hanlen*2+1];
    int len=0;

    for(int n=0; n<cx->FixedNum; ++n)
	len += WcLen(StrListNthWc(cx->FixedYomi.adr,cx->FixedNum,n));
    SjStrHan2Zen(sjzen,(char*)cs+cs->dwCompReadStrOffset,2,0x40,1,hanlen);
    len += strlen(sjzen)/2;

    ImmUnlockIMCC(ic->hCompStr);
    ImmUnlockIMC(imc);
    return len;
}

/*
  °ʸֹ֤
  ʸ̵뤹
*/
int GetAttrCl(HIMC imc,char at,const CannaContext_t* cx)
{
    INPUTCONTEXT *ic = (INPUTCONTEXT*)ImmLockIMC(imc);
    COMPOSITIONSTRING *cs = (COMPOSITIONSTRING*)ImmLockIMCC(ic->hCompStr);
    int num;
    int cllen = cs->dwCompClauseLen/4-1;
    int32_t* cl = (int32_t*)((char*)cs+cs->dwCompClauseOffset);
    char* attr = (char*)cs+cs->dwCompAttrOffset;

    for(num=0; num<cllen; ++num){
	if(attr[cl[num]] == at)
	    break;
    }
    
    ImmUnlockIMCC(ic->hCompStr);
    ImmUnlockIMC(imc);

    return num<cllen ? cx->FixedNum+num : -1;
}

int WcToMb(const uint16_t* w,int wlen,char* m,int mlen)
{
    int sz = WideCharToMultiByte(CP_ACP,0,(LPCWSTR)w,wlen,m,mlen,NULL,NULL);
    m[sz] = 0;
    return sz;
}


/*
  (clpos_e<=ʸֹ<clpos_e)ޤǤCOMPOSITIONSTRINGscsɲä
  ʸֹimcǤο͡ cx->FixedNumϹθƤʤΤǤ餫Ƥȡ
  ʸˤϺǸǡʸˤդusingˤϥȤʤ

  ClauseStr(),GetInputClause()ȽʣƤ...
 */
void StoreComp(Array scs[],HIMC imc,int clpos_b,int clpos_e,int en)
{
    int32_t *cl,*rcl;
    int strlen,rdlen,n;

    INPUTCONTEXT *ic = (INPUTCONTEXT*)ImmLockIMC(imc);
    COMPOSITIONSTRING *cs = (COMPOSITIONSTRING*)ImmLockIMCC(ic->hCompStr);

    if(clpos_e < 0)
	clpos_e = cs->dwCompClauseLen/4-1;
    cl = (int32_t*)((char*)cs+cs->dwCompClauseOffset);
    strlen = cl[clpos_e]-cl[clpos_b];
    rcl = (int32_t*)((char*)cs+cs->dwCompReadClauseOffset);
    rdlen = rcl[clpos_e]-rcl[clpos_b];

    int ncl = clpos_e-clpos_b+1; //ʸ+1
    int32_t cl_s[ncl],cl_r[ncl];
    for(n=0; n<ncl; ++n){
	cl_s[n] = cl[clpos_b+n]-cl[clpos_b];
	cl_r[n] = rcl[clpos_b+n]-rcl[clpos_b];
    }
    if(en & EN_STRCL){
	ArAddN(scs+CS_STRCL,cl_s,ncl);
	-- scs[CS_STRCL].using;
    }
    if(en & EN_READCL){
	ArAddN(scs+CS_READCL,cl_r,ncl);
	-- scs[CS_READCL].using;
    }

    if(en & EN_STR)
	ArAddN(scs+CS_STR,(uint16_t*)((char*)cs+cs->dwCompStrOffset) + cl[clpos_b],strlen);
    if(en & EN_READ)
	ArAddN(scs+CS_READ,(uint16_t*)((char*)cs+cs->dwCompReadStrOffset) + rcl[clpos_b],rdlen);

    if(en & EN_STRATTR)
	ArAddN(scs+CS_STRATTR,(char*)cs+cs->dwCompAttrOffset + cl[clpos_b],strlen);
    if(en & EN_READATTR)
	ArAddN(scs+CS_READATTR,(char*)cs+cs->dwCompReadAttrOffset + rcl[clpos_b],rdlen);

    ImmUnlockIMCC(ic->hCompStr);
    ImmUnlockIMC(imc);
}

/*
  scsƤimc˥åȤ
  ʸ᤬ĤʤȼԤ롣StoreCompʸ򤷤Ƥȡ
*/
bool LoadComp(Array scs[],HIMC imc)
{
    if(scs[CS_STR].using == 0){
	return ImmNotifyIME(imc,NI_COMPOSITIONSTR,CPS_CANCEL,0);
    }

    int n=0,actmax=3;
    int act[][3]={{SCS_SETSTR,CS_STR,CS_READ},
		  {SCS_CHANGECLAUSE,CS_STRCL,CS_READCL},
		  {SCS_CHANGEATTR,CS_STRATTR,CS_READATTR},
    };
    Array *css,*csr;
    /* ??? °ʸꤹ롣
       ʸꤹȼưŪƬʸ᤬ʸˤʤ褦
       °ꤹȤߤξ֤ƱImmSetCompositionStringWfail
       ֤(atokΤȤ)
       ʤΤǡscsƬʸ°ʸλϲ⤷ʤȤˤ롣
    */

    //ʸκǸʸɲä
    ArAdd(scs+CS_STRCL,&scs[CS_STR].using);
    ArAdd(scs+CS_READCL,&scs[CS_READ].using);

    char a = *(char*)(scs[CS_STRATTR].adr);
    if(a==ATTR_TARGET_CONVERTED || a==ATTR_TARGET_NOTCONVERTED)
	--actmax; //°ꤷʤ

    do{
	css = scs + act[n][1];
	csr = scs + act[n][2];
    }while(ImmSetCompositionStringW(imc,act[n][0],css->adr,css->using*css->blocksize,csr->adr,csr->using*csr->blocksize) && ++n<actmax);

    return n==actmax && ImmNotifyIME(imc,NI_COMPOSITIONSTR,CPS_CONVERT,0);
}

void CompNew(Array scs[])
{
    int bs[CS_MAX]={[CS_STR]=2,[CS_STRCL]=4,[CS_STRATTR]=1,[CS_READ]=2,[CS_READCL]=4,[CS_READATTR]=1};

    for(int n=0; n<CS_MAX; ++n)
	ArNew(scs+n,bs[n],NULL);
}

void CompDelete(Array scs[])
{
    for(int n=0; n<CS_MAX; ++n)
	ArDelete(scs+n);
}

/*
  ʸ°
*/
char GetAttr(HIMC imc,int cl,const CannaContext_t* cx)
{
    char a;
    ClauseStr(imc,cl,NULL,1,&a,cx);
    return a;
}
